//+------------------------------------------------------------------+
//|                                              Black&White-T01.mq4 |
//|                          Copyright  2008, HomeSoft-Tartan Corp. |
//|                                              spiky@transkeino.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, HomeSoft-Tartan Corp."
#property link      "spiky@transkeino.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Gold
#property indicator_width1  2

//---- input parameters
extern int       t3_period = 14;
extern double    b         = 0.7;
extern int       mBar      = 300;

double  wsum,bsum,sum,SumBuff[],e1,e2,e3,e4,e5,e6,c1,c2,c3,c4,n,w1,w2,b2,b3,t3;
int cnt,shift,tt;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SumBuff);
   b2=b*b; 
   b3=b2*b; 
   c1=-b3; 
   c2=(3*(b2+b3)); 
   c3=-3*(2*b2+b+b3); 
   c4=(1+3*b+b3+3*b2); 
   n=t3_period;
if(n<1) n=1; 
   n=1+0.5*(n-1); 
   w1=2/(n+1); 
   w2=1-w1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
       wsum=0;bsum=0;
       
   if (tt!=Time[0])
    {   
  for (shift=mBar+1;shift>0;shift--)
    {
   if (shift==0) {tt=Time[0];break;}
   if (Close[shift]>Open[shift]) wsum=wsum+((Close[shift]-Open[shift])/Point);
   if (Close[shift]<Open[shift]) bsum=bsum+((Close[shift]-Open[shift])/Point);
       sum=wsum+bsum;
       e1=w1*sum+w2*e1; e2=w1*e1+w2*e2; e3=w1*e2+w2*e3; e4=w1*e3+w2*e4; e5=w1*e4+w2*e5; e6=w1*e5+w2*e6;
       t3=c1*e6+c2*e5+c3*e4+c4*e3;       
       
       SumBuff[shift]=t3;SumBuff[shift-1]=SumBuff[shift]+((Close[shift-1]-Open[shift-1])/Point);
    }
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+